# The React Hooks - SASS project template

This project is generated by [code-template-generator](https://www.npmjs.com/package/code-template-generator). View more information and other project templates on [GitHub](https://github.com/nguyenkhois/build-environments).

## Dependencies
Main packages:
* [React Hooks](https://reactjs.org/)
* [Babel](https://babeljs.io/docs/en)
* [SASS](https://sass-lang.com/)
* [Webpack](https://webpack.js.org/concepts/)
* [Webpack Dev Server](https://webpack.js.org/configuration/dev-server/)
* [Optimize CSS Assets plugin for Webpack](https://github.com/NMFR/optimize-css-assets-webpack-plugin)
* [Terser plugin for Webpack](https://github.com/webpack-contrib/terser-webpack-plugin)

## Features
|Description|Location|
|---|---|
|Source code|`/src`|
|Components|`/src/components`|
|Images|`/src/images`|
|Styles|`/src/styles`|
|HTML template|`/src/index.html`|
|Main entry point|`/src/index.js`|
|Webpack Dev Server custom config|`/webpack.custom.js`|

* Auto refresh whenever you make a change in your code.
* Directory `/dist` is deleted and then created automatic whenever you run the command `npm run build`.
* CSS, JS files are injected automatic into the HTML template file `index.html`.
* Code splitting - Your code are compiled into the directory `/dist` with three separate file extensions `*.html, *.css, *.js`.
* Image handling - Auto copy only the directory `/src/images` into `/dist` when you compile your code or during the development.
* Support `async`/ `await` syntax.

View more about the features on [GitHub](https://github.com/nguyenkhois/build-environments).

Tested on:
* Windows 10 version 1903
* MacOS version 10.13
* Ubuntu version 18.04 LTS

## Usage
* The commands:
    * `npm install` - Installs all needed dependencies.
    * `npm run start` - Starts Webpack Dev Server by the development mode.
    * `npm run build` - Bundles your app into the folder `/dist` by the production mode.
* Local web server is started at `htpp://localhost:9000`

## References
* [Browserslist](https://github.com/browserslist/browserslist)
* [Webpack Code Splitting](https://webpack.js.org/guides/code-splitting/)
* [SplitChunksPlugin](https://webpack.js.org/plugins/split-chunks-plugin/)